unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    N1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;



var
  Form1: TForm1;

implementation

uses
 EffectBass;

{$R *.DFM}


//-----------------------------------------------------------------------------
//֐@   EffectCustom
//pr     JX^tB^
//     hBMP             ...]̃rbg}bṽnh
//           MaskBits         ...}XNrbg(K9̔z쐬)
//                               ĺu-255v-u255v܂
//           Divisor          ...(1-255)
//           Bias             ...Z(0-255)
//߂l
//           GtFNg̃rbg}bṽnh
//-----------------------------------------------------------------------------

function EffectCustom(hBMP: HBitmap;MaskBits : array of Smallint;Divisor,Bias:BYTE):HBitmap;
var
  Row,Col,yRow,xCol,lngCount,r,g,b,X,y,EAX: Integer;
  DestRow          : pRGBArray;
  SourceBits       : PPBits;
  _Height,_Width   : integer;
  SrcBitmap,DestBitmap  : TBitmap;
begin
 SrcBitmap   :=TBitmap.Create;
 DestBitmap  :=TBitmap.Create;
 SrcBitmap.Handle  :=hBMP;
 Set24bit(SrcBitmap,DestBitmap);
 _Height := SrcBitmap.height-1;
 _Width  := SrcBitmap.width-1;

   GetMem(SourceBits, SrcBitmap.Height * SizeOf(pRGBArray));
try
   for Row:= 0 to SrcBitmap.Height - 1 do  SourceBits[Row]:=SrcBitmap.Scanline[Row];

   For Row := 0 To _Height   do
   begin

        DestRow:=DestBitmap.ScanLine[Row];

        For Col := 0 To _Width do
        begin
            //-------------
            // 0 - 1 - 2
            //-------------
            // 3 - 4 - 5
            //-------------
            // 6 - 7 - 8
            //-------------
            R:=0;G:=0;B:=0; EAX:=0;
            for y:= -1 to 1 do
            begin
              for x:= -1 to 1 do
              begin
                 //Y
                 if      Row+(y)> _Height then
                  yRow:=_Height
                 else if Row+(y)< 0       then
                  yRow:=0
                 else
                   yRow:=Row+(y);
                 //X
                 if      Col+(x)> _Width  then  xCol:=_Width
                 else if Col+(x)< 0       then  xCol:=0
                 else
                   xCol:=Col+(x);

                 B:=B+(SourceBits[yRow][xCol].rgbtBlue*MaskBits[EAX]);
                 G:=G+(SourceBits[yRow][xCol].rgbtGreen*MaskBits[EAX]);
                 R:=R+(SourceBits[yRow][xCol].rgbtRed*MaskBits[EAX]);
                 inc(EAX);
              end;
            end;

           DestRow[Col].rgbtRed   :=Set255((R div Divisor)+Bias);
           DestRow[Col].rgbtGreen :=Set255((G div Divisor)+Bias);
           DestRow[Col].rgbtBlue  :=Set255((B div Divisor)+Bias);

       end;
    end;

  FreeMem(SourceBits); SourceBits:=nil;
  Result :=DestBitmap.ReleaseHandle;

  except
     if Assigned(SourceBits) then FreeMem(SourceBits);
     Result :=SrcBitmap.ReleaseHandle;
  end;
  SrcBitmap.Free ;
  DestBitmap.Free;
end;


/////////
procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 begin
   Image1.Picture.bitmap.LoadFromFIle(OpenDialog1.FIlename);
   N1.Enabled :=true;
 end;
end;

/////////
procedure TForm1.N1Click(Sender: TObject);
Var
  MaskBits   : array[0..8] of Smallint;  //}XNrbg
  Divisor :integer;                      //
  Bias :byte;                            //Z
begin

 //J[G{X
 Divisor:=1; Bias:=0;
 Divisor:=1;
 MaskBits[0]:= -1;   MaskBits[1]:= -1;   MaskBits[2]:=-1;
 MaskBits[3]:= 0;    MaskBits[4]:= 1;    MaskBits[5]:= 0;
 MaskBits[6]:= 1;    MaskBits[7]:= 1;    MaskBits[8]:= 1;

 //Run
 Image1.Picture.bitmap.Handle:= EffectCustom(Image1.Picture.Bitmap.ReleaseHandle,MaskBits,Divisor,Bias);
end;

end.
